/***************************************************************************
 *   Copyright (C) 2006 by AST   *
 *   tsyplyaev@gmail.com   *
 *   ICQ: 279-533-134                          *
 *   This is a part of work done by AST.       *
 *   If you want to use it, please contact me. *
 ***************************************************************************/

//***************************************************************************
#include "ILSystem.h"
#include "Log.h"
//***************************************************************************

namespace ASTEngine {

ILSystem *ilSystem;

//---------------------------------------------------------------------------
//Desc:    creates new ILSystem
//Params:  -
//Returns: pointer to new ILSystem
//---------------------------------------------------------------------------
ILSystem *ILSystem::create() {
	if(ilSystem) { return ilSystem; };

	ilSystem = new ILSystem();

	Log::write("ILSystem::create()");
	Log::write("{");
	Log::write("}\n");
	
	ilInit();
	iluInit();

	return ilSystem;
};

//---------------------------------------------------------------------------
//Desc:    returns existing ILSystem
//Params:  -
//Returns: pointer to existing ILSystem
//---------------------------------------------------------------------------
ILSystem *ILSystem::get() {
	return ilSystem;
};

//---------------------------------------------------------------------------
//Desc:    ILSystem destructor
//Params:  -
//Returns: -
//---------------------------------------------------------------------------
ILSystem::~ILSystem() {
};

};